﻿using Caliburn.Micro;
using System;
using System.ComponentModel.Composition;
using System.Linq;
using VisualComponents.Create3D;
using VisualComponents.UX.Shared;

namespace Plugin.TextBoxInRibbonGroup
{
    interface ITextBoxDemoInterface : ITextEditorTool
    {

    }

    [Export(typeof(IActionItem))]
    [Export(typeof(ITextBoxDemoInterface))]
    public class Demo : ActionItem , ITextBoxDemoInterface
    {
        Random rnd;
        public Demo() : base("TextBoxDemo", "Text Box Demo", "", null, MenuTools.TextEditorTool, false, false)
        {
            CanExecute = true;
            EditAreaWidth = 100;
            IsReadOnly = true;
            rnd = new Random();
            var number = rnd.Next(1, 10000);
            Text = number;
        }


        private bool _canExecute;
        public new bool CanExecute
        {
            get
            {
                return _canExecute;
            }
            set
            {
                if (_canExecute != value)
                {
                    _canExecute = value;
                    NotifyOfPropertyChange(() => CanExecute);
                }
            }
        }

        private object _text;
        public object Text
        {
            get
            {
                return _text;
            }
            set
            {
                _text = value;
                NotifyOfPropertyChange(() => Text);
            }
        }

        private bool _isReadOnly;
        public bool IsReadOnly
        {
            get
            {
                return _isReadOnly;
            }
                
            set
            {
                _isReadOnly = value;
            }
        }

        private double _editAreaWidth;
        public double EditAreaWidth
        {
            get
            {
                return _editAreaWidth;
            }
            set
            {
                _editAreaWidth = value;
            }
        }
               
        public void OnPreviewKeyDown(string text, System.Windows.Input.KeyEventArgs e)
        {
            //throw new NotImplementedException();
        }
    }


    [Export(typeof(IActionItem))]
    public class Demo1 : ActionItem
    {
        Random rnd;
        ITextBoxDemoInterface demo;
        public Demo1() : base("TextBoxButton", "Text Box Button", "", null, MenuTools.ButtonTool, false, false)
        {
            CanExecute = true;
            demo = IoC.Get<ITextBoxDemoInterface>();
            rnd = new Random();
        }

        private bool _canExecute;
        public new bool CanExecute
        {
            get
            {
                return _canExecute;
            }
            set
            {
                if (_canExecute != value)
                {
                    _canExecute = value;
                    NotifyOfPropertyChange(() => CanExecute);
                }
            }
        }

        public override void Execute()
        {                 
            var number = rnd.Next(1, 10000);
            var demoAt = demo as ITextEditorTool;
            demoAt.Text = "";
            demoAt.Text = number;
        }

    }


    [Export(typeof(IPlugin))]
    public class RegisterPlugin : IPlugin
    {
        public void Exit()
        {

        }

        public void Initialize()
        {
            ICommandRegistry cmd = IoC.Get<ICommandRegistry>();

            var actionItem = cmd.FindItem("TextBoxDemo");

            var item = new UXSiteSetup
            {
                UXSiteIdPath = "VcTabHome/VcRibbonGridSnap",
                EntryId = actionItem.Id
            };
            cmd.RegisterActionItem(actionItem, item);


            var actionItem1 = cmd.FindItem("TextBoxButton");

            var item1 = new UXSiteSetup
            {
                UXSiteIdPath = "VcTabHome/VcRibbonGridSnap",
                EntryId = actionItem1.Id
            };
            cmd.RegisterActionItem(actionItem1, item1);
        }
    }
}
